/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER     "0.1"



void bpftp_pwddec(unsigned char *password);



int main(int argc, char *argv[]) {
    setbuf(stdout, NULL);

    fputs("\n"
        "Bullet Proof FTP default password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <password*>\n"
            "\n"
            "* the password is that at line 5 of the file Default.bps\n"
            "\n", argv[0]);
        exit(1);
    }

    bpftp_pwddec(argv[1] + 2);
    printf("\nDecoded password: %s\n\n", argv[1] + 2);

    return(0);
}



void bpftp_pwddec(unsigned char *password) {
    unsigned int long  test;
    unsigned int       tmp;
    int                 len;
    unsigned char       *pwd,
                        *ptr,
                        eax,
                        edx,
                        edi;

    len = strlen(password) >> 1;
    tmp = 0x003F8A7A + len;
    ptr = pwd = password;
    while(len--) {
        tmp *= 0x08088405;
        test = ++tmp;
        test *= 0xfa;
        edi = test >> 32;
        eax = *pwd++ - 'a';
        eax = (eax << 4) - eax;
        edx = *pwd++ - 'a';
        *ptr++ = (eax + edx) ^ edi;
    }
    *ptr = 0;
}



